'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FakeCodeTypingLine = require('./FakeCodeTypingLine');

var _FakeCodeTypingLine2 = _interopRequireDefault(_FakeCodeTypingLine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/no-array-index-key */

var FakeCodeTyping = function (_Component) {
  _inherits(FakeCodeTyping, _Component);

  function FakeCodeTyping() {
    _classCallCheck(this, FakeCodeTyping);

    return _possibleConstructorReturn(this, (FakeCodeTyping.__proto__ || Object.getPrototypeOf(FakeCodeTyping)).apply(this, arguments));
  }

  _createClass(FakeCodeTyping, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          speed = _props.speed;
      var className = this.props.className;


      var lines = children.props.children.split('\n');

      className += ' fake-code-typing';
      var delay = 0;
      var duration = 0;
      var lineLen = lines.length;

      return _react2.default.createElement(
        'div',
        { className: className.trim() },
        _react2.default.createElement(
          'pre',
          null,
          lines.map(function (line, i) {
            var count = line.length;
            delay += duration;
            duration = count / speed;

            return _react2.default.createElement(
              'div',
              { key: i },
              _react2.default.createElement(
                _FakeCodeTypingLine2.default,
                {
                  keepBorder: lineLen === i + 1,
                  count: count,
                  duration: duration,
                  delay: delay
                },
                line
              ),
              '\n'
            );
          })
        )
      );
    }
  }]);

  return FakeCodeTyping;
}(_react.Component);

FakeCodeTyping.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]).isRequired,
  className: _propTypes2.default.string,
  speed: _propTypes2.default.number
};

FakeCodeTyping.defaultProps = {
  speed: 12,
  className: ''
};

exports.default = FakeCodeTyping;